/**
 * <p>Title: Force Field Explorer</p>
 * <p>Description: Force Field Explorer provides a user interface to TINKER</p>
 * <p>Copyright: Copyright (c) 2004 Jay Ponder</p>
 * <p>Institution: Washington University</p>
 * @author Michael J. Schnieders
 * @version 4.2
 */

package ffe.lang;

import java.util.Vector;

/**
 * The Keyword class holds a single TINKER keyword entry.
 */
public class Keyword{

   private String keyword = null;

   /**
    * It seems convenient to just use the Strings allocated by the FileReader
    * and pass them into the KeywordData class.
    */
   private Vector data = new Vector();

   public Keyword(String k){
      keyword = k;
   }

   public Keyword(String k, String entry){
      this(k);
      data.add(entry);
   }

   public Keyword(String k, String entry[]){
      this(k);
      for (int i = 0; i < entry.length; i++){
         data.add(entry[i]);
      }
   }

   public void append(String entry){
      data.add(entry);
   }

   public void append(String entry[]){
      for (int i = 0; i < entry.length; i++){
         data.add(entry[i]);
      }
   }

   public void clear(){
      data.clear();
   }

   public String getKeyword(){
      return keyword;
   }

   public Vector getEntries(){
      return data;
   }

   public String getEntry(int i){
      return (String) data.get(i);
   }

   public String toString(){
      StringBuffer sb = new StringBuffer(keyword + " ");
      for (int i = 0; i < data.size(); i++){
         sb.append((String) data.get(i));
      }
      return sb.toString();
   }

   public void print(){
      System.out.println(toString());
   }

}
