/**
 * <p>Title: Force Field Explorer</p>
 * <p>Description: Force Field Explorer provides a user interface to TINKER</p>
 * <p>Copyright: Copyright (c) 2004 Jay Ponder</p>
 * <p>Institution: Washington University</p>
 * @author Michael J. Schnieders
 * @version 4.2
 */

package ffe.net;

import java.io.Serializable;

/**
 * The FMessage class is used to pass simple messages the FServer and FClient(s).
 */
public class FMessage
   implements Serializable{

   private int message = 0;
   private int step = -1;
   private double time = -1.0;
   private int type = 0;

   public FMessage(int m){
      message = m;
   }

   public int getMessage(){
      return message;
   }

   public int getStep(){
      return step;
   }

   public double getTime(){
      return time;
   }

   public int getType(){
      return type;
   }

   public void print(){
      System.out.println("FMessage: " + toString());
   }

   public void setMessage(int m){
      message = m;
   }

   public void setStep(int s){
      step = s;
   }

   public void setTime(double t){
      time = t;
   }

   public void setType(int t){
      type = t;
   }

   public String toString(){
      if (message == 0){
         return new String("SYSTEM").intern();
      } else if (message == 1){
         return new String("UPDATE").intern();
      } else if (message == 2){
         return new String("CLOSING").intern();
      } else{
         return new String("OK").intern();
      }
   }

   public static int SYSTEM = 0;
   public static int UPDATE = 1;
   public static int CLOSING = 2;
   public static int OK = 3;
}
