/**
 * <p>Title: Force Field Explorer</p>
 * <p>Description: Force Field Explorer provides a user interface to TINKER</p>
 * <p>Copyright: Copyright (c) 2004 Jay Ponder</p>
 * <p>Institution: Washington University</p>
 * @author Michael J. Schnieders
 * @version 4.2
 */

package ffe.panels;

import java.util.*;

/**
 * The FFELocale class will encapsulate Internationalization features, if
 * there is interest.
 */

public class FFELocale{
   Locale[] supportedLocales = {Locale.ENGLISH};
   Locale currentLocale;
   PropertyResourceBundle guiLabels;

   public FFELocale(){
      currentLocale = Locale.getDefault();
      guiLabels = (PropertyResourceBundle) ResourceBundle.getBundle("ffe.properties.GUIBundle",
                  currentLocale);
   }

   public FFELocale(Locale locale){
      currentLocale = locale;
      guiLabels = (PropertyResourceBundle) ResourceBundle.getBundle("ffe.properties.GUIBundle",
                  currentLocale);

   }

   public void list(){
      Enumeration bundleKeys = guiLabels.getKeys();

      while (bundleKeys.hasMoreElements()){
         String key = (String) bundleKeys.nextElement();
         String value = guiLabels.getString(key);
         System.out.println("key = " + key + ", " + "value = " + value);
      }
   }

   public String getGUILabel(String key){
      return guiLabels.getString(key);
   }
}
