/**
 * <p>Title: Force Field Explorer</p>
 * <p>Description: Force Field Explorer provides a user interface to TINKER</p>
 * <p>Copyright: Copyright (c) 2004 Jay Ponder</p>
 * <p>Institution: Washington University</p>
 * @author Michael J. Schnieders
 * @version 4.2
 */

package ffe.panels;

import javax.media.j3d.*;

import java.awt.*;
import javax.swing.JPanel;

/**
 * The GraphicsPanel class contains the 3D Canvas and its status box.
 */
public class GraphicsPanel
   extends JPanel{

   private Graphics3D graphics;
   private JPanel canvasPanel;
   private JPanel statusPanel;

   public GraphicsPanel(Graphics3D g, JPanel s){
      super(new BorderLayout());
      statusPanel = s;
      if (g != null){
         canvasPanel = new JPanel(new GridLayout(1, 1));
         canvasPanel.add(g);
         //init2ndView();
         add(canvasPanel, BorderLayout.CENTER);
      } else{
         setBackground(Color.BLACK);
      }
      add(statusPanel, BorderLayout.SOUTH);
   }

   public void setVisible(boolean v){
      super.setVisible(v);
      if (graphics != null){
         graphics.setVisible(v);
      }
   }

   public void init2ndView(){
      GraphicsConfigTemplate3D template3D = new GraphicsConfigTemplate3D();
      template3D.setDoubleBuffer(GraphicsConfigTemplate.PREFERRED);
      GraphicsConfiguration gc = GraphicsEnvironment.getLocalGraphicsEnvironment().
                                 getDefaultScreenDevice().getBestConfiguration(template3D);
      Canvas3D canvas2 = new Canvas3D(gc);
      graphics.getView().addCanvas3D(canvas2);
      canvasPanel.add(canvas2);
   }
}
