/**
 * <p>Title: Force Field Explorer</p>
 * <p>Description: Force Field Explorer provides a user interface to TINKER</p>
 * <p>Copyright: Copyright (c) 2004 Jay Ponder</p>
 * <p>Institution: Washington University</p>
 * @author Michael J. Schnieders
 * @version 4.2
 */

package ffe.parsers;

import ffe.lang.FSystem;
import ffe.panels.MainPanel;

/**
 * The CloseFile class wraps the closing of an FSystem within a thread.
 */
public final class CloseFile
   implements Runnable{

   FSystem s;
   MainPanel tink;
   ffe.panels.Graphics3D graphics;

   public CloseFile(FSystem sys, MainPanel tp, ffe.panels.Graphics3D g){
      s = sys;
      tink = tp;
      graphics = g;
   }

   public void run(){
      s.setClosing(true);
      if (graphics.sceneRendering()){
         synchronized (this){
            try{
               wait(50);
            } catch (Exception e){
               System.out.println("" + e);
            }
         }
      }
      graphics.remove(s);
      graphics.centerView();
      s.destroy();
   }
}
