/**
 * <p>Title: Force Field Explorer</p>
 * <p>Description: Force Field Explorer provides a user interface to TINKER</p>
 * <p>Copyright: Copyright (c) 2004 Jay Ponder</p>
 * <p>Institution: Washington University</p>
 * @author Michael J. Schnieders
 * @version 4.2
 */

package ffe.xml;

import java.net.URL;

import org.xml.sax.*;

/**
 * The DTDResolver class just points the DOM DocumentBuilder to the XML
 * Document Type Definition files.
 */

public class DTDResolver
   implements EntityResolver{
   public InputSource resolveEntity(String publicId, String systemId){
      //System.out.println("" + systemId);
      if (systemId.lastIndexOf("keywords.dtd") >= 0){
         URL keyURL = getClass().getClassLoader().getResource("ffe/xml/keywords.dtd");
         try{
            return new InputSource(keyURL.openStream());
         } catch (Exception e){
            System.out.println("" + e);
            return null;
         }
      } else if (systemId.lastIndexOf("commands.dtd") >= 0){
         URL commandURL = getClass().getClassLoader().getResource("ffe/xml/commands.dtd");
         try{
            return new InputSource(commandURL.openStream());
         } catch (Exception e){
            return null;
         }
      }
      return null;
   }
}
